What is new in Mentry 4.5?
--------------------------

1. Included the same version 2.25 of the mega-widget utility package
   mwutil as in the most recent Tablelist, Scrollutil, and Tsw releases.

2. Added a new demo script (and its tile-based version) implementing a
   multi-entry widget for 20-character Franking IDs used by the German
   postal service (thanks to Ralf Richard Goebel for his proposal).

3. Included a description of the new demo script in the Mentry
   Programmer's Guide.

4. Improved the documentation, mainly by extending the CSS stylesheet
   used in the HTML files.

What was new in Mentry 4.4?
---------------------------

1. Included the same version 2.24 of the mega-widget utility package
   mwutil as in the most recent Tablelist, Scrollutil, and Tsw releases.

2. Minor improvements in the documentation.

What was new in Mentry 4.3.1?
-----------------------------

1. Made sure that the Migration Tool for Tcl 9 by Ashok Nadkarni won't
   output any warnings or notes (thanks to Andreas Kupries for his
   valuable input).

What was new in Mentry 4.3?
---------------------------

1. Made sure that the handling of the <TouchpadScroll> event won't
   pollute the global namespace (thanks to Rolf Ade for drawing my
   attention to this issue).

2. Loading the package no longer sets a global variable (thanks to
   Emiliano Gavilan for reporting this issue).

3. The "put" subcommand no longer moves the focus temporarily from the
   mentry widget to the containing toplevel window (thanks to Emiliano
   Gavilan for his bug report).

4. Restored the support for Tcl/Tk 8.4, which was broken due to the use
   of package version numbers with a trailing "-" (thanks to Samuel
   Brown for his bug report).

What was new in Mentry 4.2?
---------------------------

1. Adapted to the recent improvements in the "classic" theme by Emiliano
   Gavilan.

2. Adapted the default value of the "-selectborderwidth" option in
   Mentry_tile to recent changes in the "default" and "classic" themes.

What was new in Mentry 4.1?
---------------------------

1. Fixed a long-standing bug due to which under some circumstances the
   default values of several configuration options became theme-specific
   even if the mentry package rather than mentry_tile was being used.

2. Fixed a typo in the mega-widget utility file mwutil.tcl, introduced
   in the previous release (thanks to Harald Oehlmann for his bug
   report).

What was new in Mentry 4.0?
---------------------------

1. Dropped the support for Tk versions earlier than 8.4.  This has made
   the code simpler and easier to maintain.

2. Adapted to the changes made in the Entry and TEntry bindings in Tk
   8.7.

3. Added explicit support for the themes "black", "breeze",
   "breeze-dark", "sun-valley-light", and "sun-valley-dark".

4. Improved the compatibility with Tcl 9 and Tk 8.7/9.  For example,
   added support for the new <TouchpadScroll> event, introduced in Tk
   8.7 and 9.

5. Updated the Wcb command reference "wcbRef.html" to the version
   included in the most recent Wcb release 4.0.

What was new in Mentry 3.18?
----------------------------

1. For Tcl versions 8.4 and later replaced the deprecated "trace
   variable" invocations with "trace add variable".

What was new in Mentry 3.17?
----------------------------

1. Extended the description of the "mentry::setThemeDefaults" command by
   the hint that with current Mentry_tile versions there is no need for
   invocations of this procedure in application code.

2. Included the same version 2.20 of the mega-widget utility package
   mwutil as in the most recent Tablelist release 6.21.

3. Fixed a bug related to the comparison of package versions.

What was new in Mentry 3.16?
----------------------------

1. Updated the Wcb command reference "wcbRef.html" to the version
   included in the most recent Wcb release 3.8.

2. Corrected a typo in the copyright information contained in the file
   "mentry_tile.tcl" (thanks to Stuart Cassoff for his bug report).

What was new in Mentry 3.15?
----------------------------

1. Fixed a bug related to the handling of the <<ThemeChanged>> event
   when the package Mentry rather than Mentry_tile was loaded into the
   interpreter (thanks to "saitology9" for reporting a similar bug in
   Tablelist).

2. Improved and updated the documentation.

What was new in Mentry 3.14?
----------------------------

1. Extended the "adjustentry" subcommand by an optional second string
   argument and used this extended form in the implementation of the
   "mentry::fixedPointMentry" command.  This significantly improves the
   layout of the mentry widgets of type "FixedPoint".

2. Added code that handles the virtual event <<TkWorldChanged>> with the
   "user_data" field (%d) set to "FontChanged", which, with Tk versions
   later than 8.6.11 and 8.7.a5, will be sent by the Tk engine to all
   widgets when a font is changed, for example, by invoking "font
   configure" (see TIP 608).

3. Added bindings that handle <<Paste>> events in the entry components
   of the mentry widgets of types "IPAddr", "IPv6Addr", "EthernetAddr",
   and "PhoneNumber" (thanks to Paul Obermeier for his proposal).

4. Improved and updated the documentation.

What was new in Mentry 3.13?
----------------------------

1. Reworked the support for the awthemes package and extended it by
   support for the "awbreezedark" theme, introduced in awthemes 10.3.

2. Included the same version 2.19 of the mega-widget utility package
   mwutil as in the most recent Tablelist release 6.13.

What was new in Mentry 3.12?
----------------------------

1. Added support for the platform-independent handling of mouse wheel
   events (TIP 474), introduced in Tk 8.7a4 (as of January 9, 2021).

2. Included the same version 2.18 of the mega-widget utility package
   mwutil as in the most recent Tablelist release 6.12.

What was new in Mentry 3.11?
----------------------------

1. Adapted the "aqua" theme support to Tk releases 8.6.10 and 8.6.11,
   including the support for the Dark Mode appearance, introduced in
   Mac OS version 10.14 (Mojave).  When using Tk 8.6.10 or later, the
   mentry widgets are now rendered according to the current system
   appearance and are updated whenever the latter toggles between Light
   Mode and Dark Mode or the Accent Color or Highlight Color in the
   General Preferences changes.

2. Added support for the "awdark", "awlight", and the five other themes
   provided by the package awthemes 9.4 or later by Brad Lanam.

3. Added the virtual event <<MentryThemeDefaultsChanged>>, sent to the
   main window when handling the virtual events <<ThemeChanged>>,
   <<LightAqua>>, and <<DarkAqua>>.  See the section "The mentry::
   setThemeDefaults Command" of the manual page "Commands Related to
   Tile Themes" for details.

4. Included the same version 2.17 of the general mega-widget utility
   module "mwutil.tcl" as in the most recent Tablelist release 6.11.

5. For current Tk versions Mentry no longer requires that changing the
   theme be done using the "ttk::setTheme" command instead of
   "ttk::style theme use", which was necessary for older tile versions.

6. Made the demo scripts scaling-aware.  In addition, with Tk 8.6.10 or
   later, they now fully support the Dark Mode appearance on Mac OS
   10.14 and later.

7. Reworked the invocations of "package vcompare", taking into account
   that Tcl versions earlier than 8.5 did not support the letters "a"
   and "b" in version numbers (thanks to Mike Walsh for his bug report).

8. Several further improvements in the code and documentation.

What was new in Mentry 3.10?
----------------------------

1. Included the same version 2.15 of the general mega-widget utility
   module "mwutil.tcl" as in the most recent Tablelist release 6.7.

2. Mentry no longer creates aliases in the "::tk" namespace for Tk
   commands for which that namespace already contains a command of the
   same name.

3. Improved the documentation.

What was new in Mentry 3.9?
---------------------------

1. Included the same version of the general mega-widget utility module
   "mwutil.tcl" as in the most recent Tablelist release 6.5.

2. Corrected two typos related to the "hasattrib" and "unsetattrib"
   subcommands.

3. Minor improvements in the documentation.

What was new in Mentry 3.8?
---------------------------

1. Added support for the themes "aquativo", "Arc", and "clearlooks";
   updated the support for several other themes.

2. Adapted to some changes in future Tcl and Tk releases (for example,
   made sure that it works with Tcl 9.0 and Tk 8.7).

3. Included the same version of the general mega-widget utility module
   "mwutil.tcl" as in the most recent Tablelist release 6.3.

4. Updated the demo scripts and the documentation.

5. Several code improvements and minor bug fixes.

What was new in Mentry 3.7?
---------------------------

1. Minor performance improvements.

2. Included the same version of the general mega-widget utility module
   "mwutil.tcl" as in Tablelist release 5.11.

3. Restored the support for Tcl/Tk 8.0, by cleaning up the use of the
   "clock" command and that of the <MouseWheel> event.

4. Improved the package loading mechanism.

5. Improved and updated the documentation.

What was new in Mentry 3.6?
---------------------------

1. The "-background" option in the package Mentry_tile now works for
   the great majority of themes.  The most notable exceptions are the
   themes "plastik", "tileqt", "vista", and "xpnative", which ignore any
   attempt to set the background color for ttk::entry widgets.

2. Adapted the code to some changes in current tile versions, to make
   sure that in disabled state the tile-based ttk::entry components of
   mentry widgets will appear in the theme-specific disabled foreground
   color, as it was the case with earlier tile versions.

3. Extended the support for the "tileqt" theme to work on KDE 4, too.

4. Guarded against scripts that start by destroying all children of the
   root window.

5. Minor improvements in the documentation.

What was new in Mentry 3.5?
---------------------------

1. Included the same version of the general mega-widget utility module
   "mwutil.tcl" as in Tablelist release 5.3.

2. Eliminated the deprecated free-form scan from the implementation of
   the "mentry::getClockVal" command for mentry widgets of types "Date",
   "Time", and "DateTime" for Tcl versions 8.5 and above.

3. Fixed a minor bug related to the handling of <Button-1> events.

What was new in Mentry 3.4?
---------------------------

The only changes contained in this release are a few adaptations made
necessary by submitting the package for inclusion in tklib (thanks to
Stuart Cassoff for his proposal and valuable assistance).

What was new in Mentry 3.3?
---------------------------

1. Added three new commands related to mentry widgets for IPv6
   addresses.

2. Support for Windows Vista (including explicit support for the "vista"
   theme).

3. Updated the support for the themes "plastik" and "keramik"; added
   support for the "keramik_alt" theme.

4. Included the same version of the general mega-widget utility module
   "mwutil.tcl" as in Tablelist release 4.12.

5. Minor improvements in the code.

What was new in Mentry 3.2?
---------------------------

1. New subcommands "adjustentry" and "setentryextrawidth", providing an
   easy way to set the optimal widths for the entry children.

2. Complemented the "attrib" subcommand with the new subcommands
   "hasattrib" and "unsetattrib".

3. Included a new mentry widget of type "DateTime" (thanks to Florian
   Murr for his proposal).

4. Added mouse wheel support for mentry widgets of types "Date", "Time",
   "DateTime", and "IPAddr".

5. Made sure that the default bindings are set up immediately when
   loading the package, prior to creating any mentry widget.

6. The "setThemeDefaults" command no longer throws an error if the
   current theme is not explicitly supported by Mentry.  Instead, it
   uses the options set by the current theme and falls back to the
   "default" one for the rest.

7. Included the same version of the general mega-widget utility module
   "mwutil.tcl" as in Tablelist release 4.10.

8. Adapted the demo scripts to use the new "adjustentry" subcommand.

What was new in Mentry 3.1?
---------------------------

1. Mentry_tile now supports tile 0.8 and Tk 8.5a6/8.5b1 (where tile is
   integrated in the core).  The new commands "mentry::setTheme",
   "mentry::getCurrentTheme", and "mentry::getThemes" enable you to set
   and get the current theme and to query the available ones, without
   having to worry about the incompatibilities between the various tile
   versions.

2. Included the same version of the general mega-widget utility module
   "mwutil.tcl" as in Tablelist release 4.6.

3. Minor improvements in the code.

What was new in Mentry 3.0?
---------------------------

1. Support for tile-compatibility:  By just specifying "package require
   Mentry_tile" instead of "package require Mentry", the mentry widgets
   will have a modern theme-specific appearance and behavior.  See the
   "How to use it?", "More on Mentry_tile", and "Tile-based demo
   scripts" sections of the tutorial "mentry.html" for details.

2. New command "mentry::setThemeDefaults", which can be used to make
   sure that classical Tk widgets, e.g., text, will have a theme-
   specific appearance, just like the tile widgets.

3. New subcommands "setentryfont" and "setentrywidth", for configuring
   individual entry components of mentry widgets.

4. Used the same package loading mechanism as in Tablelist 4.5 (thanks
   to Andreas Kupries for his valuable contribution).

5. The Mentry and Mentry_tile packages now require Wcb version 3.1.

6. The demo scripts are now provided in both a traditional and a
   tile-based version.

What was new in Mentry 2.8?
---------------------------

1. This Mentry release is compatible with both the new Wcb version 3.0
   (or higher) and the older Wcb versions 2.7 - 2.9.  (Earlier Mentry
   releases don't work with Wcb versions having the major number 3).

1. New bindings for the <Prior> and <Next> events in mentry widgets for
   date and time.

3. New bindings for the <Up>, <Down>, <Prior>, and <Next> events in
   mentry widgets for IP addresses (thanks to Jean Romier for his
   valuable contribution).

What was new in Mentry 2.7?
---------------------------

1. New bindings for the <Up> and <Down> events in mentry widgets for
   date and time.

2. Corrected three typos in the handling of the <End>, <Control-Left>,
   and <Control-Right> events, introduced in the previous Mentry
   release.

3. Worked around a bug in the "clock format ... -format %p" command
   introduced in Tcl 8.4, causing an erronous behavior of the
   "putClockVal" command in non-default locales on UNIX for "Time"
   mentries with AM/PM indicator.

4. Improved the error handling related to the option database in the
   general mega-widget utility module "mwutil.tcl".

5. Improvements in the demo scripts.

6. Many improvements in the documentation, including a new Quick
   Reference section.

What was new in Mentry 2.6?
---------------------------

This release contains no new commands or subcommands; the improvements
are mostly of internal nature:

1. Rewritten the bindings-related stuff by introducing own binding tags
   for the children of mentry widgets.  This method is more Tk-like and
   has the additional advantage that it supports arbitrary widget names
   (in earlier releases, mentry widgets couldn't have '%' characters in
   their names).

2. When creating a mentry widget, the "-colormap" frame configuration
   option is no longer used, because it is bogus in some Tk versions on
   the Macintosh (and it isn't needed anyway).

3. Included the same version of the general mega-widget utility module
   "mwutil.tcl" as in Tablelist release 3.3.

What was new in Mentry 2.5?
---------------------------

1. Applied a patch proposed (in a slightly different form) by Mats
   Bengtsson that works around a bug in the "info script" command on
   the Macintosh.

2. Improved and simplified the focus control (thanks to Juri Shimon and
   Gopal Reddy for their bug reports).

3. The invocations of "info exists" for array elements are no longer
   replaced with a call to a helper procedure (introduced in Mentry 2.0
   because of a bug in some earlier Tcl versions).

4. Improved the Mentry Programmer's Guide.

What was new in Mentry 2.4?
---------------------------

1. The "isempty" subcommand now has an optional "index" argument.

2. New "isfull" subcommand (with an optional "index" argument).

3. Simplified the demo scripts "phonenumber.tcl" and "ethernetaddr.tcl"
   by using the two subcommands mentioned above.

4. Further minor improvements in the demo scripts and documentation.

What was new in Mentry 2.3?
---------------------------

1. Reverted the implementation of the focus control to the one
   contained in the pre-2.2 Mentry releases, because its simplified
   version from the last release failed to work as expected if a
   mentry was the only widget taking the focus during keyboard
   traversal.

2. Improved the performance of the Tcl command associated with a mentry
   widget.

3. Included the same version of the general mega-widget utility module
   "mwutil.tcl" as in recent Tablelist releases.

4. Further minor improvements in the code.

5. The distribution file "mentry2_3.zip" for Windows now includes the
   "mentry2.3" directory, hence it is no longer necessary to create
   this folder before unpacking the distribution file.

What was new in Mentry 2.2?
---------------------------

1. Improved the handling of the case that all entry children of a
   mentry widget are disabled.

2. Made the focus control more straight-forward.

3. Extended the "How to use it?" section of the tutorial "mentry.html".

What was new in Mentry 2.1?
---------------------------

1. Improved the error handling in the "attrib" and "configure"
   subcommands.

2. The demo script "ethernetaddr.tcl" now uses the callback
   "wcb::checkStrForRegExp" (introduced in Wcb 2.6) instead of the
   local procedure "checkStrForHex".

3. Further minor improvements in the code.

What was new in Mentry 2.0?
---------------------------

1. When typing a character contained in the label following the current
   entry, the focus is no longer set to the next enabled entry child if
   the current entry is empty (thanks to Leslie Brooks for this
   suggestion).

2. When setting the focus to a mentry widget (e.g., with the standard
   keys Tab and Shift-Tab during keyboard traversal), its first enabled
   entry child now not only receives the focus (like in earlier
   releases), but in addition its contents is selected and the
   insertion cursor is moved to its end.

3. New "clear" subcommand to erase the contents of one or more entry
   children of a mentry widget (this was kindly proposed by Leslie
   Brooks).

4. Fixed a bug related to the initialization of the values of the
   configuration options when creating a mentry widget.

5. Whereever possible, eliminated the invocations of "info exists" for
   array elements.  This works around a bug in Tcl versions 8.2 and
   8.3.0 - 8.3.2 (fixed in 8.3.3 and 8.4a2), which causes excessive
   memory use when calling "info exists" on a non-existent array
   element.

6. The help variables used in the initialization of the "mentry"
   namespace are now declared with the "variable" keyword, in order to
   avoid any conflicts with global variables (thanks to Leslie Brooks
   for his bug report).

7. Improved the parsing of configuration and command options.

What was new in Mentry 1.5?
---------------------------

1. The "-textvariable" configuration option and the "getarray"
   subcommand now raise an error if the argument is not an array.

2. Replaced "[focus]" with "[focus -displayof $win]", so that the code
   will work properly in applications using multiple displays.

3. Renamed "mentryBindingTag" to "Mentry".

4. Improvements in the documentation.

What was new in Mentry 1.4?
---------------------------

1. The "put" subcommand now returns the value 0 if the attempted change
   gets canceled in any of the entry children by some before-delete or
   before-insert callback, and 1 otherwise.

2. For Tk versions 8.4 or higher the "mentry::mentry" command now
   supports the "-disabledbackground", "-disabledforeground", and
   "-readonlybackground" configuration options, as well as the value
   "readonly" for the "-state" configuration option.

3. Improved the error-handling and the geometry management in the
   implementation of the "-body" configuration option.

4. Moved several procedures from the file "mentryWidget.tcl" into the
   new general mega-widget utility module "mwutil.tcl".

5. Minor improvements in the demo scripts.

What was new in Mentry 1.3?
---------------------------

1. Changed the implementation of the "-takefocus" configuration option,
   in order to work around a bug in the Tk library file "focus.tcl",
   introduced in Tk 8.3.1.

2. The "put" subcommand now restores the original contents of all
   affected entry children of the mentry widget if the change gets
   canceled in any of the entries by some before-delete or before-
   insert callback.  (Thanks to Aryeh Koenigsberg for his suggestion.)

3. Fixed a small bug in the "attrib" subcommand.

4. Minor improvements in the code.

What was new in Mentry 1.2?
---------------------------

1. Improved the behavior of mentry widgets during keyboard traversal
   with the standard keys:  Shift-Tab now moves the focus out of the
   current mentry instead of setting it to the first enabled entry
   child of the widget, as it was the case in earlier releases.

2. The "mentry::mentry" command now supports the "-takefocus"
   configuration option.

3. For Tk versions 8.3 or higher the "mentry::mentry" command now
   supports the "-invalidcommand", "-validate", and "-validatecommand"
   configuration options.

What was new in Mentry 1.1?
---------------------------

1. The tutorial and the mentry widget reference page now contain
   hyperlinks to the Wcb command reference, which has been included in
   the documentation.

2. Minor improvements in the code and documentation.

What was new in Mentry 1.0?
---------------------------

1. As promised in Version 0.9, the Mentry package now includes a
   tutorial and reference pages in HTML format.

2. The Tcl command corresponding to a mentry widget now has a new
   subcommand named "entrylimit".

3. The package no longer makes use of any undocumented, private Tk
   library routines.

4. A new demo script "phonenumber.tcl" is provided and discussed in the
   tutorial.
